"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable-next-line:no-reference
/// <reference path="../node_modules/dropbox/dist/dropbox.d.ts" />
var Dropbox = require('dropbox');
var data = require('../tests/test_data.json');
var assert = require("assert-plus");
var uuid = require("uuid");
var index_1 = require("./index");
var fs = require("fs");
var path = require("path");
var chai = require("chai");
var expect = chai.expect;
// verify data
assert.string(data.access_token, 'access_token');
assert.ok(data.access_token !== '', 'access_token');
assert.arrayOfObject(data.uploads, 'uploads');
assert.string(data.unitTestBaseFolder, 'unitTestBaseFolder');
// client
var client = new Dropbox({ accessToken: data.access_token });
var baseDir = data.unitTestBaseFolder + '/' + uuid.v4();
before(function () { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, client.filesCreateFolderV2({
                    path: baseDir
                })];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
after(function () { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, client.filesDeleteV2({
                    path: baseDir
                })];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
describe('running testData.uploads', function () {
    var _loop_1 = function (upload) {
        it("upload -> " + upload.localFilePath, function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runTestForUpload(upload)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it("upload cancellation -> " + upload.localFilePath, function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runTestForUpload(upload, true)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, _a = data.uploads; _i < _a.length; _i++) {
        var upload = _a[_i];
        _loop_1(upload);
    }
});
function runTestForUpload(upload, testCancellation) {
    if (testCancellation === void 0) { testCancellation = false; }
    return __awaiter(this, void 0, void 0, function () {
        var localFilePath, destination, size, args, unit, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    assert.string(upload.localFilePath, 'localFilePath');
                    assert.string(upload.destination, 'destination');
                    localFilePath = path.resolve(__dirname, '../tests', upload.localFilePath);
                    destination = baseDir + '/' + upload.destination;
                    size = fs.statSync(localFilePath).size;
                    args = {
                        access_token: data.access_token,
                        readable_stream: fs.createReadStream(localFilePath),
                        file_size: size,
                        destination: destination,
                        forced_chunked_upload: upload.forced_chunked_upload === undefined ? false : upload.forced_chunked_upload,
                        autorename: false,
                        mode: 'add',
                        chunk_size: upload.chunk_size
                    };
                    if (testCancellation) {
                        setTimeout(function () {
                            args.cancel();
                        }, 10);
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, index_1.default(args)];
                case 2:
                    unit = _a.sent();
                    chai.assert.notOk(testCancellation, 'upload should have been cancelled');
                    expect(unit).to.have.property('path_lower', destination.toLowerCase());
                    expect(unit).to.have.property('size', size);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    if (!testCancellation) {
                        throw err_1;
                    }
                    expect(err_1).to.have.property('message', 'user_aborted');
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
